﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
  public partial class InsertNodeDialog : Form {
    public InsertNodeDialog() {
      InitializeComponent();
    }

    public void SetAllowedSymbols(IEnumerable<ISymbol> symbols) {
      allowedSymbolsCombo.Items.Clear();
      foreach (var s in symbols) allowedSymbolsCombo.Items.Add(s);
      allowedSymbolsCombo.SelectedIndex = 0;
    }

    public ISymbol SelectedSymbol() {
      return (ISymbol)allowedSymbolsCombo.SelectedItem;
    }

    private void allowedSymbolsCombo_SelectedIndexChanged(object sender, EventArgs e) {
      return; // not sure what to do yet
      var combo = (ComboBox)sender;
      var symbol = combo.Items[combo.SelectedIndex];
      if (symbol is Constant) {
        // add controls to the dialog for changing the constant value
        variableNameLabel.Visible = false;
        variableNamesCombo.Visible = false;
        variableWeightLabel.Visible = false;
        variableWeightTextBox.Visible = false;
        constantValueLabel.Visible = true;
        constantValueTextBox.Visible = true;
      } else if (symbol is Variable) {
        var variable = (Variable)symbol;
        foreach (var name in variable.VariableNames) variableNamesCombo.Items.Add(name);
        variableNamesCombo.SelectedIndex = 0;
        variableNameLabel.Visible = true;
        variableNamesCombo.Visible = true;
        variableWeightLabel.Visible = true;
        variableWeightTextBox.Visible = true;
        constantValueLabel.Visible = false;
        constantValueTextBox.Visible = false;
        // add controls to the dialog for changing the variable name or weight
      }
    }

    private void childControl_KeyDown(object sender, KeyEventArgs e) {
      insertNodeDialog_KeyDown(sender, e);
    }

    private void insertNodeDialog_KeyDown(object sender, KeyEventArgs e) {
      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return) {
        if (ValidateChildren()) {
          DialogValidated(this, e);
          Close();
        }
      }
    }

    public event EventHandler DialogValidated;
  }
}
